"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function OpenDialog() {
    var options = {
        dialogName: 'custom',
        position: 1
    };
    var data = {
        my_guid: Xrm.Page.data.entity.getId(),
    };
    Xrm.Navigation.openDialog("CustomDialog", options, data);
}
function onClick_Cancel() {
    Xrm.Page.ui.close();
}
function onClick_OK() {
    return __awaiter(this, void 0, void 0, function* () {
        var inputParameters = {
            opportunityId: Xrm.Page.data.attributes.get("my_guid").getValue(),
            statuscode: Xrm.Page.data.attributes.get("my_statuscode").getValue(),
            description: Xrm.Page.data.attributes.get("my_description").getValue()
        };

        yield LoseOpportunity(inputParameters);
    });
};

function LoseOpportunity(inputParameters) {
    return __awaiter(this, void 0, void 0, function* () {
        var opportunityclose = {
            "opportunityid@odata.bind": "/opportunities" + inputParameters.opportunityId.replace("{", "(").replace("}", ")"),
            "@odata.type": "Microsoft.Dynamics.CRM.opportunityclose",
            "actualrevenue": 0,
            "actualend": new Date(),
            "description": inputParameters.description
        };
        var loseOpportunityRequest = {
            OpportunityClose: opportunityclose,
            Status: inputParameters.statuscode,
            getMetadata: function () {
                return {
                    boundParameter: null,
                    parameterTypes: {
                        "OpportunityClose": {
                            "typeName": "mscrm.opportunityclose",
                            "structuralProperty": 5
                        },
                        "Status": {
                            "typeName": "Edm.Int32",
                            "structuralProperty": 1
                        }
                    },
                    operationType: 0,
                    operationName: "LoseOpportunity"
                };
            }
        };
        yield Xrm.WebApi.online.execute(loseOpportunityRequest);
        yield Xrm.Page.ui.close();
        yield parent.window.location.reload();
    });
}
